<template>
  <div class="card shadow" :class="type === 'dark' ? 'bg-default': ''">
    <div class="card-header border-0" :class="type === 'dark' ? 'bg-transparent': ''">
      <div class="row align-items-center">
        <div class="col">
          <h3 class="mb-0">Materializations</h3>
        </div>
      </div>
    </div>

    <div class="table-responsive">
      <base-table class="table align-items-center table-flush"
                  :class="type === 'dark' ? 'table-dark': ''"
                  :thead-classes="type === 'dark' ? 'thead-dark': 'thead-light'"
                  tbody-classes="list"
                  :data="tableData">
        <template slot="columns">
          <th>MZID</th>
          <th>Nodes</th>
          <th>Links</th>
          <th>Age</th>
          <th>Status</th>
          <th></th>
        </template>

        <template slot-scope="{row}">
          <th scope="row">
            <div class="media align-items-center">
              <div class="media-body">
                <span class="name mb-0 text-sm">{{row.Info.Mzid}}</span>
              </div>
            </div>
          </th>
          <td>
            {{row.Nodes}}
          </td>
          <td>
            {{row.Links}}
          </td>
          <td>
            <div>
                {{row.Age.toString().toHHMMSS()}}
            </div>
          </td>

          <td>
            <div class="d-flex align-items-center">
              <span class="completion mr-2">{{Math.round((row.Completed / row.Total)*100)}}%</span>
              <div>
                <base-progress type="gradient-primary"
                               :show-percentage="false"
                               class="pt-0"
                               :value="Math.round((row.Completed / row.Total)*100)"/>
              </div>
            </div>
          </td>

          <td class="text-right">
            <base-dropdown class="dropdown"
                           position="right">
              <a slot="title" class="btn btn-sm btn-icon-only text-light" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <i class="fas fa-ellipsis-v"></i>
              </a>

              <template>
                <a class="dropdown-item" :href="'/#/materialization/tasks/'+row.Info.Mzid">Tasks</a>
                <a class="dropdown-item" :href="'/#/materialization/infranet/'+row.Info.Mzid">Infranet</a>
                <a class="dropdown-item" :href="'/#/materialization/xpnet/'+row.Info.Mzid">Xpnet</a>
              </template>
            </base-dropdown>
          </td>

        </template>

      </base-table>
    </div>

  </div>
</template>
<script>
  const axios = require('axios').default;
  import '../../util.js'
  export default {
    name: 'materialization-table',
    props: {
      type: {
        type: String
      },
      title: String
    },
    data() {
      return {tableData: []}
    },
    mounted() {
        axios
            .get(location.origin+'/api/materializations')
            .then( response => {
                this.tableData = response.data 
            })
            .finally(() => this.loading = false)
    }
  }
</script>
<style>
</style>
